Unit mni01_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure mni01(var H :Array of Real; NOR :Integer; IEGEN :Integer;
                var U :Array of Real; var NR :Integer; NDIM :Integer;
                var X :Array of Real; NOUNIT :Integer; ACCURA :Real);

implementation

procedure mni01(var H :Array of Real; NOR :Integer; IEGEN :Integer;
                var U :Array of Real; var NR :Integer; NDIM :Integer;
                var X :Array of Real; NOUNIT :Integer; ACCURA :Real);
var
M,N,IMAX,IPIV,JPIV,L,J,I :Integer;
XMAX,CHAN,XX,S2,C2,A,B,HII,HIJ,HJL,HJJ,SIN,COS :Real;
label
_1,_2,_3,_5,_7,_10,_11,_18,_19,_20,_25,_27,_30,_31,_33,_40,_50,_55,
_60,_70,_71,_75,_80,_999,_100,_103,_104,_105,_106,_109,_110,_998;
begin
NR := 0;
if ( NOR ) < 0
 then goto _999
 else if ( NOR ) > 0
       then goto _1
       else goto _999;
_1:
if ( IEGEN ) < 0
 then goto _10
 else if ( IEGEN ) > 0
       then goto _10
       else goto _2;
_2:
if ( NOUNIT ) < 0
 then goto _10
 else if ( NOUNIT ) > 0
       then goto _10
       else goto _3;
_3:
for M:=1 to NOR do
 begin
  for N:=1 to NOR do
   begin
_5:
    U[( N-1)+(M -1)*NDIM] := 0.0;
   end;
 end;
for M:=1 to NOR do
 begin
_7:
  U[( M-1)+(M-1)*NDIM] := 1.0;
 end;
_10:
if ( NOR-1 ) < 0
 then goto _999
 else if ( NOR-1 ) > 0
       then goto _11
       else goto _999;
_11:
XMAX := 0.0;
IMAX := 1;
for M:=1 to NOR do
 begin
  X[M -1] := 0.0;
  HII := H[( M-1)+(M -1)*NDIM];
  H[( M-1)+(M -1)*NDIM] := 0.0;
  for N:=1 to NOR do
   begin
_18:
    X[M -1] := H[( N-1)+(M -1)*NDIM]*H[(N-1)+(M-1)*NDIM]+X[M-1];
   end;
  if ( X[M -1] - XMAX ) < 0
   then goto _20
   else if ( X[M -1] - XMAX ) > 0
         then goto _19
         else goto _20;
_19:
  IMAX := M;
  XMAX := X[M -1];
_20:
  H[( M-1)+(M -1)*NDIM] := HII;
 end;
IPIV := IMAX;
CHAN := 1.0;
_25:
XMAX := 0.0;
IMAX := 1;
HII := H[( IPIV-1)+(IPIV -1)*NDIM];
H[( IPIV-1)+( IPIV -1)*NDIM] := 0.0;
for J:=1 to NOR do
 begin
  A := Abs(H[(J-1)+(IPIV -1)*NDIM]);
  if ( A - XMAX ) < 0
   then goto _30
   else if ( A - XMAX ) > 0
         then goto _27
         else goto _30;
_27:
  XMAX := A;
  IMAX := J;
_30:
 end;
JPIV := IMAX;
H[( IPIV-1)+( IPIV -1)*NDIM] := HII;
if ( JPIV - IPIV ) < 0
 then goto _31
 else if ( JPIV - IPIV ) > 0
       then goto _31
       else goto _999;
_31:
HIJ := H[( IPIV-1)+( JPIV -1)*NDIM];
if ( Abs(HIJ)- ACCURA ) < 0
 then goto _999
 else if ( Abs(HIJ)- ACCURA ) > 0
       then goto _33
       else goto _999;
_33:
NR := NR + 1;
HJJ := H[( JPIV-1)+( JPIV -1)*NDIM];
A := HII - HJJ;
SIN := Sign( 1.0, HIJ * A );
A := 0.5 * Abs( A ) / Sqrt( A * A + HIJ * HIJ * 4.0);
SIN := SIN * Sqrt( Abs( 0.5 - A ) );
COS := Sqrt( 0.5 + A );
XX := 0.0;
for J:=1 to NOR do
 begin
  A := H[( J-1)+( IPIV-1)*NDIM];
  XX := XX + A * H[(J-1)+(JPIV-1)*NDIM];
  H[(J-1)+( IPIV-1)*NDIM] := A*COS +H[(J-1)+(JPIV-1)*NDIM]*SIN;
_40:
  H[(J-1)+(JPIV-1)*NDIM] := H[(J-1)+(JPIV-1)*NDIM]*COS-A*SIN;
 end;
H[( IPIV-1)+( IPIV -1)*NDIM] := H[( IPIV-1)+( IPIV -1)*NDIM] * COS + H[( JPIV-1)+( IPIV -1)*NDIM] * SIN;
H[( JPIV-1)+( JPIV -1)*NDIM] := H[( JPIV-1)+( JPIV -1)*NDIM] * COS - H[( IPIV-1)+( JPIV -1)*NDIM] * SIN;
for I:=1 to NOR do
 begin
  H[(IPIV-1)+(I-1)*NDIM] := H[(I-1)+(IPIV-1)*NDIM];
_50:
  H[( JPIV-1)+(I-1)*NDIM] := H[(I-1)+(JPIV-1)*NDIM];
 end;
if ( IEGEN ) < 0
 then goto _70
 else if ( IEGEN ) > 0
       then goto _70
       else goto _55;
_55:
for J:=1 to NOR do
 begin
  A := U[(J-1)+( IPIV-1)*NDIM];
  U[(J-1)+(IPIV -1)*NDIM] := A*COS+U[(J-1)+(JPIV-1)*NDIM]*SIN;
_60:
  U[(J-1)+(JPIV-1)*NDIM] := U[(J-1)+(JPIV-1)*NDIM]*COS-A*SIN;
 end;
_70:
H[( IPIV-1)+( JPIV -1)*NDIM] := 0.0;
H[( JPIV-1)+( IPIV -1)*NDIM] := 0.0;
if ( CHAN ) < 0
 then goto _999
 else if ( CHAN ) > 0
       then goto _71
       else goto _999;
_71:
S2 := SIN * SIN;
C2 := 1.0 - S2;
XX := XX * SIN * COS *2.0;
A := X[IPIV-1];
X[IPIV-1] := C2 * A + S2 * X[JPIV -1] + XX - ( H[( IPIV-1)+(IPIV-1)*NDIM] *
    H[(IPIV-1)+(IPIV-1)*NDIM] - C2 * HII * HII - S2 * HJJ * HJJ);
X[JPIV -1] := S2 * A + C2 * X[JPIV -1] - XX - ( H[( JPIV-1)+(JPIV -1)*NDIM]
    * H[(JPIV-1)+(JPIV-1)*NDIM] - S2 * HII * HII - C2 * HJJ * HJJ  );
XMAX := 0.0;
IMAX := 1;
for L:=1 to NOR do
 begin
  if ( X[L -1] - XMAX ) < 0
   then goto _80
   else if ( X[L -1] - XMAX ) > 0
         then goto _75
         else goto _80;
_75:
  IMAX := L;
  XMAX := X[L -1];
_80:
 end;
IPIV := IMAX;
goto _25;
_999:
_100:
CHAN := 0.0;
for N:=1 to NOR do
 begin
  X[N-1] := 0.0;
  HII := H[( N-1)+(N-1)*NDIM];
  for M:=1 to NOR do
   begin
    if ( N- M ) < 0
     then goto _103
     else if ( N- M ) > 0
           then goto _103
           else goto _109;
_103:
    A := HII - H[(M-1)+(M-1)*NDIM];
    B := Abs( A );
    if ( ACCURA - B ) < 0
     then goto _106
     else if ( ACCURA - B ) > 0
           then goto _104
           else goto _106;
_104:
    SIN := ACCURA * ACCURA;
    if ( Abs( H[( M-1)+(N  -1)*NDIM])- SIN* SIN* B ) < 0
     then goto _109
     else if ( Abs( H[( M-1)+(N  -1)*NDIM])- SIN* SIN* B ) > 0
           then goto _105
           else goto _109;
_105:
    HIJ := H[(M-1)+(N-1)*NDIM];
    IPIV := N;
    JPIV := M;
    goto _33;
_106:
    X[N-1] := X[N-1] + H[(M-1)+(N-1)*NDIM]*H[(M-1)+(N-1)*NDIM]/A;
_109:
   end;
 end;
for N:=1 to NOR do
 begin
_110:
  H[(N-1)+(N-1)*NDIM] := H[(N-1)+(N-1)*NDIM] + X[N-1];
 end;
_998:
end;

end.
