{    var   : }
{ N }
Unit MNI2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNI01_p;

procedure MNI2R(var N :Integer; var B22 :Real; E :Real;
                var K2 :Integer; var PIK :Array of Real;
                var BK :Array of Real; var X :Array of Real;
                var XP :Array of Real; var Z :Array of Real;
                var Z1 :Array of Real; var QL :Array of Real;
                var W1 :Array of Real; var X0 :Array of Real;
                var V1 :Real; FUN :Proc_F1_MN);

implementation

procedure MNI2R(var N :Integer; var B22 :Real; E :Real;
                var K2 :Integer; var PIK :Array of Real;
                var BK :Array of Real; var X :Array of Real;
                var XP :Array of Real; var Z :Array of Real;
                var Z1 :Array of Real; var QL :Array of Real;
                var W1 :Array of Real; var X0 :Array of Real;
                var V1 :Real; FUN :Proc_F1_MN);
var
K1,KI,K4,J,NF,K,I,M,L2,L1,L,NR,N1 :Integer;
HK,FE,B21,V,C1,C2,CX0,CZ1,AV,T,E2,B1,BF,F10,F11,E1,F12,C100 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_241,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,
_36,_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,
_53,_54,_55,_56,_57;
begin
{  MNI01-/ BC. CO. BEKTOPOB. }
{  N CO EPEMEHHX }
{  X MACCB HAAHX HAEH }
{  B22 HAEHE YHK B TOKE X }
{  E KPTEP PEKPAEH BCEH }
{  K2 CO TPEYEMX TEPA }
{  V1 BEHA HAAHOO AA }
{  X XP Z Z1 QL W1 PIK BK PAOE MACCB }
K1 := 0;
KI := 0;
HK := 0.01;
K4 := 0;
for J:=1 to N do
 begin
  W1[J-1] := 0.0;
  QL[J-1] := 1;
_1:
  X[J-1] := X0[J-1];
 end;
FUN(X,B22,FE);
NF := NF+1;
B21 := B22;
for J:=1 to N do
 begin
  for M:=1 to N do
   begin
_2:
    PIK[(J-1)+(M-1)*N] := 0;
   end;
 end;
for J:=1 to N do
 begin
_3:
  PIK[(J-1)+(J-1)*N] := 1.0;
 end;
K := 0;
goto _30;
_4:
I := 1;
_5:
V := V1;
K4 := 0;
for J:=1 to N do
 begin
_6:
  XP[J-1] := X[J-1]+V*PIK[(J-1)+(I-1)*N];
 end;
W1[I-1] := W1[I-1]+V;
FUN(XP,C1,FE);
NF := NF+1;
if ( C1-B22 ) < 0
 then goto _8
 else if ( C1-B22 ) > 0
       then goto _7
       else goto _8;
_7:
V := -V;
_8:
for J:=1 to N do
 begin
_9:
  Z[J-1] := XP[J-1]+V*PIK[(J-1)+(I-1)*N];
 end;
W1[I-1] := W1[I-1]+V;
if ( W1[I-1]-1.E+10 ) < 0
 then goto _10
 else if ( W1[I-1]-1.E+10 ) > 0
       then goto _19
       else goto _10;
_10:
FUN(Z,C2,FE);
NF := NF+1;
if ( K4 ) < 0
 then goto _16
 else if ( K4 ) > 0
       then goto _16
       else goto _11;
_11:
if ( C2-C1 ) < 0
 then goto _12
 else if ( C2-C1 ) > 0
       then goto _13
       else goto _12;
_12:
V := 2*V;
goto _8;
_13:
for J:=1 to N do
 begin
_14:
  Z1[J-1] := Z[J-1];
 end;
for J:=1 to N do
 begin
_15:
  X0[J-1] := XP[J-1];
 end;
CX0 := C1;
CZ1 := C2;
V := V/2;
K4 := 10;
goto _8;
_16:
AV := 2*(CX0-2*C2+CZ1);
if ( Abs(AV)-1.E-17 ) < 0
 then goto _54
 else if ( Abs(AV)-1.E-17 ) > 0
       then goto _17
       else goto _54;
_17:
AV := (V*(CX0-CZ1))/AV;
KI := 0;
for J:=1 to N do
 begin
_18:
  X[J-1] := Z[J-1]+AV*PIK[(J-1)+(I-1)*N];
 end;
FUN(X,B22,FE);
NF := NF+1;
W1[I-1] := W1[I-1]+AV;
_19:
I := I+1;
if ( I-N ) < 0
 then goto _5
 else if ( I-N ) > 0
       then goto _20
       else goto _5;
_20:
V1 := V1/2.0;
T := B22-B21;
if ( E ) < 0
 then goto _21
 else if ( E ) > 0
       then goto _21
       else goto _22;
_21:
if ( Abs(T)-Abs(E) ) < 0
 then goto _56
 else if ( Abs(T)-Abs(E) ) > 0
       then goto _22
       else goto _56;
_22:
B21 := B22;
E2 := E2/2;
HK := Abs(W1[0]);
L2 := N-1;
for J:=1 to L2 do
 begin
  B1 := Abs(W1[J+0]);
  if ( HK-B1 ) < 0
   then goto _23
   else if ( HK-B1 ) > 0
         then goto _24
         else goto _23;
_23:
  HK := B1;
_24:
 end;
_241:
if ( HK-1.E-9 ) < 0
 then goto _25
 else if ( HK-1.E-9 ) > 0
       then goto _26
       else goto _25;
_25:
HK := 1.E-7;
_26:
if ( HK-1.E-3 ) < 0
 then goto _28
 else if ( HK-1.E-3 ) > 0
       then goto _27
       else goto _28;
_27:
HK := 1.E-3;
_28:
for J:=1 to N do
 begin
_29:
  W1[J-1] := 0.0;
 end;
goto _38;
_30:
BF := B22;
for J:=1 to N do
 begin
  for M:=1 to N do
   begin
_31:
    Z[M-1] := X[M-1]+HK*PIK[(M-1)+(J-1)*N];
   end;
  FUN(Z,F10,FE);
  NF := NF+1;
_32:
  Z1[J-1] := F10;
 end;
for L:=1 to N do
 begin
  for J:=L to N do
   begin
    for M:=1 to N do
     begin
_33:
      XP[M-1] := X[M-1]+HK*PIK[(M-1)+(L-1)*N]+HK*PIK[(M-1)+(J-1)*N];
     end;
    FUN(XP,F10,FE);
    NF := NF+1;
    T := F10-Z1[L-1]-Z1[J-1]+BF;
    if ( Abs(T)-1.E+18*(IntPower(HK,2)) ) < 0
     then goto _35
     else if ( Abs(T)-1.E+18*(IntPower(HK,2)) ) > 0
           then goto _34
           else goto _34;
_34:
    BK[(L-1)+(J-1)*N] := 1.E+16;
    goto _36;
_35:
    BK[(L-1)+(J-1)*N] := T/(IntPower(HK,2));
_36:
   end;
 end;
for L:=2 to N do
 begin
  L1 := L-1;
  for J:=1 to L1 do
   begin
_37:
    BK[(L-1)+(J-1)*N] := BK[(J-1)+(L-1)*N];
   end;
 end;
MNI01(BK,N,0,PIK,NR,N,XP,1,HK);
goto _4;
_38:
E1 := HK;
for J:=1 to N do
 begin
_39:
  QL[J-1] := BK[(J-1)+(J-1)*N];
 end;
for J:=1 to N do
 begin
  if ( Abs(QL[J-1])-0.5E-16 ) < 0
   then goto _41
   else if ( Abs(QL[J-1])-0.5E-16 ) > 0
         then goto _40
         else goto _41;
_40:
 end;
N1 := N;
goto _42;
_41:
N1 := J-1;
_42:
for J:=1 to N do
 begin
  Z[J-1] := 0.0;
  for M:=1 to N do
   begin
_43:
    BK[(J-1)+(M-1)*N] := 0.0;
   end;
 end;
for J:=1 to N1 do
 begin
_44:
  BK[(J-1)+(J-1)*N] := 1.0/QL[J-1];
 end;
for I:=1 to N1 do
 begin
  for J:=1 to N do
   begin
_45:
    XP[J-1] := X[J-1]+E1*PIK[(J-1)+(I-1)*N];
   end;
  FUN(XP,F11,FE);
  NF := NF+1;
  for J:=1 to N do
   begin
_46:
    Z1[J-1] := X[J-1]-E1*PIK[(J-1)+(I-1)*N];
   end;
  FUN(Z1,F12,FE);
  NF := NF+1;
  T := F11-F12;
  if ( 2*E1-Abs(T)*1.E-17 ) < 0
   then goto _30
   else if ( 2*E1-Abs(T)*1.E-17 ) > 0
         then goto _47
         else goto _30;
_47:
  Z[I-1] := T/(2*E1);
 end;
for J:=1 to N1 do
 begin
_48:
  Z[J-1] := Z[J-1]*BK[(J-1)+(J-1)*N];
 end;
for I:=1 to N do
 begin
  Z1[I-1] := 0.0;
  for J:=1 to N1 do
   begin
_49:
    Z1[I-1] := Z1[I-1]+PIK[(I-1)+(J-1)*N]*Z[J-1];
   end;
 end;
for J:=1 to N1 do
 begin
_50:
  XP[J-1] := X[J-1]-Z1[J-1];
 end;
FUN(XP,C100,FE);
NF := NF+1;
if ( B22-C100 ) < 0
 then goto _30
 else if ( B22-C100 ) > 0
       then goto _51
       else goto _30;
_51:
for J:=1 to N do
 begin
_52:
  X[J-1] := XP[J-1];
 end;
B22 := C100;
K := K+1;
if ( E ) < 0
 then goto _30
 else if ( E ) > 0
       then goto _30
       else goto _53;
_53:
if ( K-K2 ) < 0
 then goto _30
 else if ( K-K2 ) > 0
       then goto _30
       else goto _56;
_54:
KI := KI+1;
if ( KI-10 ) < 0
 then goto _241
 else if ( KI-10 ) > 0
       then goto _55
       else goto _241;
_55:
_56:
for J:=1 to N do
 begin
_57:
  X0[J-1] := X[J-1];
 end;
K2 := NF;
end;

end.
